// ==================================================================
// This file is part of Smart Render.
//
// Smart Render is free software: you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
//
// Smart Render is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Smart Render. If not, see <http://www.gnu.org/licenses/>.
// ==================================================================

package net.smart.render;

import java.util.*;

import net.minecraftforge.fml.client.registry.*;
import net.minecraft.client.*;
import net.minecraft.client.entity.*;
import net.minecraft.client.renderer.entity.*;

import net.smart.utilities.*;

public abstract class SmartRenderContext extends SmartRenderUtilities
{
	public static void registerRenderers(Class<?> type)
	{
		RenderManager manager = Minecraft.getMinecraft().getRenderManager();

		Render defaultRender;
		try
		{
			defaultRender = (Render)type.getConstructor(RenderManager.class).newInstance(manager);
		}
		catch (Exception e)
		{
			throw new RuntimeException("Unable to create player renderer", e);
		}

		RenderingRegistry.registerEntityRenderingHandler(EntityPlayerSP.class, defaultRender);
		RenderingRegistry.registerEntityRenderingHandler(EntityOtherPlayerMP.class, defaultRender);
		Reflect.SetField(RenderManager.class, manager, SmartRenderInstall.RenderManager_renderPlayer, defaultRender);

		Map skinMap = (Map)Reflect.GetField(RenderManager.class, manager, SmartRenderInstall.RenderManager_skinMap);
		skinMap.put("default", defaultRender);

		Render slimRender;
		try
		{
			slimRender = (Render)type.getConstructor(RenderManager.class, boolean.class).newInstance(manager, true);
		}
		catch (Exception e)
		{
			throw new RuntimeException("Unable to create player slim renderer", e);
		}

		skinMap.put("slim", slimRender);
	}
}